/*

  Microsoft Windows Embedded Seminar 2007

    Module Name:
        Drv01TestApp.c

	Note
		This application call to Driver02.dll work buffer.
		User application can not access to kernel area directly.

	Copyright(c) 2007 Yu Ito All rights reserved.

*/

#include <windows.h>
#include "..\Driver01\Drv01_cmd.h"

int WINAPI
WinMain(
	HINSTANCE	hInstance,
	HINSTANCE	hPrevInstance,
	LPWSTR		lpCmdLine,
	int			nCmdShow
	)
{
	HANDLE	hDrv01;
	DWORD	i;
	DWORD	dwReturnValue;
	DRV01_RWBUFFER Drv01Buffer;
	BYTE	nBuffer;

	// Driver Driver01 open
	hDrv01 = CreateFile (
				TEXT("DRV1:"),
				GENERIC_READ | GENERIC_WRITE,
				0,
				NULL,
				OPEN_EXISTING,
				FILE_ATTRIBUTE_NORMAL,
				NULL
				);
	if ( !hDrv01 ) {					// don't open
		RETAILMSG (1, (TEXT("Driver01 open function is failed.\r\n")));
		return 0;
	}

	// I will set data for Driver01 work area.
	Drv01Buffer.pData = &nBuffer;

	for ( i = 0; i < 32 ; i++ ){
		Drv01Buffer.dwOffset = i;
		*Drv01Buffer.pData = (BYTE)(i & 0xff);
		DeviceIoControl(
			hDrv01,
			CMD_WRITE_1BYTE,
			(LPVOID)&Drv01Buffer,
			sizeof(DRV01_RWBUFFER),
			NULL,
			0,
			&dwReturnValue,
			NULL
			);
	}

	// I will read Driver01 work area.
	Drv01Buffer.pData = &nBuffer;
	for ( i = 0; i < 32 ; i++ ){
		Drv01Buffer.dwOffset = i;
		DeviceIoControl(
			hDrv01,
			CMD_READ_1BYTE,
			(LPVOID)&Drv01Buffer,
			sizeof(DRV01_RWBUFFER),
			NULL,
			0,
			&dwReturnValue,
			NULL
			);
		RETAILMSG (1, (TEXT("%02x \r\n"), nBuffer ));
	}

	CloseHandle ( hDrv01 );

	return 0;
}
