/*

  Microsoft Windows Embedded Seminar 2007

    Module Name:
        Drv02TestMemory.c

	Note
		This application read/write to Driver02.dll work buffer.

	Copyright(c) 2007 Yu Ito All rights reserved.

*/

#include <windows.h>
#include "..\Driver02\Drv02_cmd.h"

int WINAPI
WinMain(
	HINSTANCE	hInstance,
	HINSTANCE	hPrevInstance,
	LPWSTR		lpCmdLine,
	int			nCmdShow
	)
{
	HANDLE	hDrv02;
	DWORD	dwReturnValue;
	DRV02_RWBUFFER Drv02Buffer;
	BYTE	nBuffer;

	// Driver Driver02 open
	hDrv02 = CreateFile (
				TEXT("DRV2:"),
				GENERIC_READ | GENERIC_WRITE,
				0,
				NULL,
				OPEN_EXISTING,
				FILE_ATTRIBUTE_NORMAL,
				NULL
				);
	if ( !hDrv02 ) {					// don't open
		RETAILMSG (1, (TEXT("Driver02 open function is failed.\r\n")));
		return 0;
	}

	// I will set data for Driver02 work area.
	Drv02Buffer.pData = &nBuffer;
	Drv02Buffer.dwOffset = 0;
	*Drv02Buffer.pData = 0xff;

	try{
		DeviceIoControl(
			hDrv02,
			CMD_WRITE_1BYTE,
			(LPVOID)&Drv02Buffer,
			sizeof(DRV02_RWBUFFER),
			NULL,
			0,
			&dwReturnValue,
			NULL
			);
	} except (GetExceptionCode() == STATUS_ACCESS_VIOLATION ?
					EXCEPTION_EXECUTE_HANDLER : EXCEPTION_CONTINUE_SEARCH) {
  		RETAILMSG (1, (TEXT("There is exception in Driver02.dll\r\n")));
	}

	// I will read Driver02 work area.
	Drv02Buffer.pData = &nBuffer;
	Drv02Buffer.dwOffset = 0;
	*Drv02Buffer.pData = 0x00;

	try{
		DeviceIoControl(
			hDrv02,
			CMD_READ_1BYTE,
			(LPVOID)&Drv02Buffer,
			sizeof(DRV02_RWBUFFER),
			NULL,
			0,
			&dwReturnValue,
			NULL
			);
		RETAILMSG (1, (TEXT("%02x \r\n"), nBuffer ));
	} except (GetExceptionCode() == STATUS_ACCESS_VIOLATION ?
					EXCEPTION_EXECUTE_HANDLER : EXCEPTION_CONTINUE_SEARCH) {
		RETAILMSG (1, (TEXT("There is exception in Driver02.dll\r\n")));
	}

	CloseHandle ( hDrv02 );

	return 0;
}
