/*

  Microsoft Windows Embedded Seminar 2007

    Module Name:
        Drv02TestMemory2.c

	Note

	Copyright(c) 2007 Yu Ito All rights reserved.

*/

#include <windows.h>
#include "..\Driver02\Drv02_cmd.h"

#define	CALLER_BUFFER_SIZE	1024

int WINAPI
WinMain(
	HINSTANCE	hInstance,
	HINSTANCE	hPrevInstance,
	LPWSTR		lpCmdLine,
	int			nCmdShow
	)
{
	HANDLE	hDrv02;
	DWORD	dwReturnValue;
	DRV02_BUFFER	Drv02Buffer;
	PDRV02_BUFFER	p;
	DWORD	i;

	p = &Drv02Buffer;
	p->pEmbeddedPointer = VirtualAlloc(
							NULL,
							CALLER_BUFFER_SIZE,
							MEM_COMMIT,
							PAGE_READWRITE
							);
	if ( p->pEmbeddedPointer == NULL ){
		RETAILMSG(1, (TEXT("Drv02TestCallerbuffer :Failed to allocate buffer.\r\n")));
		return 0;
	}
	p->dwSize = CALLER_BUFFER_SIZE;

	for ( i = 0 ; i < CALLER_BUFFER_SIZE ; i++ ){
		*(p->pEmbeddedPointer + i ) = (BYTE)( i & 0xff );
	}

	// Driver Driver02 open
	hDrv02 = CreateFile (
				TEXT("DRV2:"),
				GENERIC_READ | GENERIC_WRITE,
				0,
				NULL,
				OPEN_EXISTING,
				FILE_ATTRIBUTE_NORMAL,
				NULL
				);
	if ( !hDrv02 ) {					// don't open
		RETAILMSG (1, (TEXT("Driver02 open function is failed.\r\n")));
		return 0;
	}

	// Caller buffer update
	DeviceIoControl(
		hDrv02,
		CMD_CLEAR_BUFFER,
		(LPVOID)p,
		sizeof(DRV02_BUFFER),
		NULL,
		0,
		&dwReturnValue,
		NULL
		);

	CloseHandle ( hDrv02 );

	if ( p->pEmbeddedPointer != NULL ){
		VirtualFree(
			p->pEmbeddedPointer,
			CALLER_BUFFER_SIZE,
			MEM_DECOMMIT
			);
	}

	return 0;
}
