/*

  Copyright(c) 2006 Yu Ito All rights reserved.

    Module Name:

        Driver01.h

    Revision History:

		2007.2.4		Released

*/

#ifndef _Driver01_H_
#define _Driver01_H_

#ifdef __cplusplus
extern "C" {
#endif

//
// Debug zones
//

#undef ZONE_ERROR
#undef ZONE_WARNING
#undef ZONE_FUNCTION
#undef ZONE_INIT

#define ZONE_ERROR      0x0001
#define ZONE_WARNING    0x0002
#define ZONE_FUNCTION   0x0004
#define ZONE_INIT       0x0008

typedef	struct __DRV01_CONTEXT {
    DWORD dwDummy;
} DRV01_CONTEXT, *PDRV01_CONTEXT;

typedef struct __LS_DRV01_INFO
{
    // Store volatile pointers to each PS2 registers
	LPBYTE				pStat;		// pointer to PS2 Status
	LPBYTE				pData;		// pointer to PS2 Data

	LPVOID				pRegBase;	// pointer to base reg for cleaning up

	HANDLE				hThread;	// handle of Driver01 IST
	BYTE				bVk;		// Virtual Key Code

	WORD				OpenCount;	// Counter for Handler

} DRV01_INFO, *PDRV01_INFO;

#endif // _Driver01_H_

